import { useEffect, useState } from 'react';
export function useDebounce(value, delay) {
    if (delay === void 0) { delay = 250; }
    var _a = useState(value), debouncedValue = _a[0], setDebouncedValue = _a[1];
    useEffect(function () {
        var timer = setTimeout(function () {
            setDebouncedValue(value);
        }, delay);
        return function () {
            clearTimeout(timer);
        };
    }, [value, delay]);
    return debouncedValue;
}
//# sourceMappingURL=index.js.map