var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import { defaultAJVMessages } from './constants';
import { customKeywordNames } from './validation';
// TODO: Is there a better way to do this?
// This is error prone because not all keywords are covered.
var getFieldName = function (field) {
    if (customKeywordNames.includes(field.keyword)) {
        return field.instancePath.slice(1);
    }
    switch (field.keyword) {
        case 'required':
            return field.params.missingProperty;
        case 'errorMessage':
        case 'minimum':
        case 'maximum':
        case 'type':
        case 'minItems':
        case 'maxItems':
        case 'minLength':
        case 'maxLength':
        case 'format':
        case 'secure-string':
            return field.instancePath.slice(1);
        default:
            return null;
    }
};
var getErrorMessage = function (error) {
    var UNKNOWN_VALIDATION_ERROR = 'Unknown validation error';
    try {
        var keyword = error.keyword;
        var errorMessageFunction = defaultAJVMessages[keyword];
        if (typeof errorMessageFunction === 'function') {
            return errorMessageFunction(error.params);
        }
        return error.message || UNKNOWN_VALIDATION_ERROR;
    }
    catch (_) {
        return UNKNOWN_VALIDATION_ERROR;
    }
};
export var getErrors = function (ajvErrors) {
    return ajvErrors.reduce(function (acc, current) {
        var _a;
        var fieldName = getFieldName(current);
        if (!fieldName) {
            return acc;
        }
        return __assign(__assign({}, acc), (_a = {}, _a[fieldName] = getErrorMessage(current), _a));
    }, {});
};
export var getInitial = function (initialState) {
    var state = {};
    for (var key in initialState) {
        if (Object.prototype.hasOwnProperty.call(initialState, key)) {
            state[key] = { value: initialState[key], error: '' };
        }
    }
    return state;
};
export var getValue = function (value) {
    if (value === null || value === undefined) {
        return '';
    }
    return value !== null && value !== void 0 ? value : '';
};
//# sourceMappingURL=index.js.map